#include <bits/stdc++.h>
//trebam jos samo napraviti kad je neki broj prvi
using namespace std;

#define ll long long
#define ld long double
#define vt vector
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(x) (int)x.size()

const int MOD=1000000007;
const int mxN=2e5+5;

int a[mxN];

void solve(){
    int n,q;
    cin >> n >> q;
    map<int,int> mp;
    for(int i=0; i<n; ++i){
        cin >> a[i];
    }
    sort(a,a+n);
    for(int i=0; i<n; ++i){
    	mp[a[i]]=i;
    }
    ll x;
    while(q--){
        cin >> x;
        if(x==a[n/2]){
            cout << 0 << "\n";
        }
        else{
            int in=0;
            if(x<=a[n-1]&&x>=a[0]){
                in=lower_bound(a,a+n,x)-a;
            }
            else{
                in=n;
            }
            ll ans=LLONG_MAX;
            if(in!=n){
                if(a[in]==x){
                    ll pre=in;
                    ll posle=n-in-1;
                    if((n+abs(pre-posle))%2==1){
                        ans=min(ans,abs(pre-posle));
                    }
                    if((n+abs(pre-posle-1))%2==0){
                        ans=min(ans,abs(pre-posle-1));
                    }
                    in=mp[a[in]];
                    pre=in;
                    posle=n-in-1;
                    if((n+abs(pre-posle))%2==1){
                        ans=min(ans,abs(pre-posle));
                    }
                    if((n+abs(pre-posle-1))%2==0){
                        ans=min(ans,abs(pre-posle-1));
                    }
                    cout << ans << "\n";
                    //cout << "ivv<3\n";
                }
                else{
                    ll pre=in;
                    ll posle=n-in;
                    if((n+abs(pre-posle))%2==0){
                        ans=min(ans,abs(pre-posle));
                    }
                    if((n+abs(pre-posle-1))%2==1){
                        ans=min(ans,abs(pre-posle-1));
                    }
                    cout << ans+1 << "\n";
                }
            }
            else{
                if(x>a[n-1]){
                	cout << n << "\n";
                }
                else{
                	cout << n+1 << "\n";
                }

            }
        }
    }
}

int main(){
    ios::sync_with_stdio(0);
	cin.tie(0);

	int t=1;
	//cin >> t;
	while(t--){
        solve();
	}
}